/******************************************
MODULO: msgctl.c
SCOPO: Illustrare il funz. di msgctl()
******************************************/
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <time.h>

void do_msgctl();
char warning_message[] = "If you remove read permission for  yourself, this program will fail frequently!";

int main(int argc, char* argv[]) {
  struct msqid_ds buf; /*buffer per msgctl()*/
  int cmd;   /* comando per msgctl() */
  int msqid; /* ID della coda da passare a msgctl() */

  if (argc!=2){
    printf("Usage: msgctl.x <msgid>\n");
    exit(1);
  }

  msqid = atoi(argv[1]);

  fprintf(stderr, "\tIPC_RMID = %d\n", IPC_RMID);
  fprintf(stderr, "\tIPC_SET = %d\n", IPC_SET);
  fprintf(stderr, "\tIPC_STAT = %d\n", IPC_STAT);
  fprintf(stderr, "\nScegliere l'opzione desiderata: ");

  scanf("%i", &cmd);
  
  switch (cmd) {
  case IPC_SET:
    fprintf(stderr, "Prima della IPC_SET, controlla i valori correnti:");
    /* notare: non e' stato inserito il break, quindi di seguito
    vengono eseguite le istruzioni del case IPC_STAT */
  
  case IPC_STAT:
    do_msgctl(msqid, IPC_STAT, &buf);
    fprintf(stderr, "msg_perm.uid = %d\n", buf.msg_perm.uid);
    fprintf(stderr,"msg_perm.gid = %d\n", buf.msg_perm.gid);
    fprintf(stderr, "msg_perm.cuid = %d\n", buf.msg_perm.cuid);
    fprintf(stderr, "msg_perm.cgid = %d\n", buf.msg_perm.cgid);
    fprintf(stderr, "msg_perm.mode = %#o, ", buf.msg_perm.mode);
    fprintf(stderr, "access permissions = %#o\n", 
                  buf.msg_perm.mode & 0777);
    fprintf(stderr, "msg_cbytes = %d\n", buf.msg_cbytes);
    fprintf(stderr, "msg_qbytes = %d\n",buf.msg_qbytes);
    fprintf(stderr, "msg_qnum = %d\n", buf.msg_qnum);
    fprintf(stderr, "msg_lspid = %d\n", buf.msg_lspid);
    fprintf(stderr, "msg_lrpid = %d\n", buf.msg_lrpid);
    if (buf.msg_stime) {
      fprintf(stderr, "msg_stime = %s\n", ctime(&buf.msg_stime));
    }
    if (buf.msg_rtime) {
      fprintf(stderr, "msg_rtime = %s\n", ctime(&buf.msg_rtime));
    } 
      fprintf(stderr, "msg_ctime = %s", ctime(&buf.msg_ctime));

    /* se il comando originario era IPC_STAT allora esco
       dal case, altrimenti proseguo con le operazioni
       specifiche per la modifica dei parametri della coda.   
    */
    if (cmd == IPC_STAT) 
      break;

    /* Modifichiamo alcuni parametri della coda */
    fprintf(stderr, "Enter msg_perm.uid: ");
    scanf ("%hi", &buf.msg_perm.uid);
    fprintf(stderr, "Enter msg_perm.gid: ");
    scanf("%hi", &buf.msg_perm.gid);
    fprintf(stderr, "%s\n", warning_message);
    fprintf(stderr, "Enter msg_perm.mode: ");
    scanf("%hi", &buf.msg_perm.mode);
    fprintf(stderr, "Enter msg_qbytes: ");
    scanf("%hi", &buf.msg_qbytes);
    do_msgctl(msqid, IPC_SET, &buf);
    break;
  
  case IPC_RMID:
  default:
    /* Rimuove la coda di messaggi. */
    do_msgctl(msqid, cmd, (struct msqid_ds *)NULL);
    break;
  }
  exit(0);
}

void do_msgctl(int msqid, int cmd, struct msqid_ds* buf) {
  int rtrn; /* per memorizzare il valore di ritorno della msgctl() */

  fprintf(stderr, "\nmsgctl: Calling msgctl(%d, %d, %s)\n",
          msqid, cmd, buf ? "&buf" : "(struct msqid_ds *)NULL");
  rtrn = msgctl(msqid, cmd, buf);

  if (rtrn == -1) {
    perror("msgctl: msgctl failed");
    exit(1);
  } else {
    fprintf(stderr, "msgctl: msgctl returned %d\n", rtrn);
  }
}
