/*
* msgget.c: Illustrate the msgget() function.
* This is a simple exerciser of the msgget() function. It prompts
* for the arguments, makes the call, and reports the results.
*/
#include <stdio.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
extern void exit();
extern void perror();
main()
{
  key_t key; /* key to be passed to msgget() */
  int msgflg, /* msgflg to be passed to msgget() */
   msqid; /* return value from msgget() */
  
  fprintf(stderr, "IPC_PRIVATE == %#lx\n", IPC_PRIVATE);
  fprintf(stderr, "Enter key: ");
  scanf("%li", &key);
  fprintf(stderr, "\nExpected flags for msgflg argument are:\n");
  fprintf(stderr, "\tIPC_EXCL =\t%#8.8o\n", IPC_EXCL);
  fprintf(stderr, "\tIPC_CREAT =\t%#8.8o\n", IPC_CREAT);
  fprintf(stderr, "\towner read =\t%#8.8o\n", 0400);
  fprintf(stderr, "\towner write =\t%#8.8o\n", 0200);
  fprintf(stderr, "\tgroup read =\t%#8.8o\n", 040);
  fprintf(stderr, "\tgroup write =\t%#8.8o\n", 020);
  fprintf(stderr, "\tother read =\t%#8.8o\n", 04);
  fprintf(stderr, "\tother write =\t%#8.8o\n", 02);
  fprintf(stderr, "Enter msgflg value: ");
  scanf("%i", &msgflg);
  fprintf(stderr, "\nmsgget: Calling msgget(%#lx,%#o)\n",key, msgflg);
  if ((msqid = msgget(key, msgflg)) == -1) {
     perror("msgget: msgget failed");
     _exit(1);
  } else {
     fprintf(stderr, "msgget: msgget succeeded: msqid = %d\n", msqid);
     _exit(0);
  }
}
