/********************************************************************   
NOME: shm1.c   
SCOPO: ``attaccare'' due volte un'area di memoria condivisa
       Ricordarsi di rimuovere la memoria condivisa al termine
       del programma lanciando shmctl.c oppure tramite il comando
       della shell ipcrm. 
*********************************************************************/
#include <stdlib.h>
#include <stdio.h>
#include <sys/types.h> 
#include <sys/ipc.h> 
#include <sys/shm.h>  
#define K 1 
#define SHMKEY 75 
#define N 10

int shmid;  
int main (int argc, char **argv) {
  int i, *pint;
  char *addr1, *addr2;
  
  /* Creao il segmento condiviso di dimensione 128*K byte */
  shmid = shmget(SHMKEY, 128*K, 0777|IPC_CREAT); 
  /* Attacco il segmento in due zone diverse */
  addr1 = shmat(shmid,0,0); 
  addr2 = shmat(shmid,0,0); 
  
  printf("Address1 = 0x%x\t Address2 = 0x%x\t\n", addr1,addr2); 
  
  /* scrivo nella regione 1 */ 
  pint = (int*)addr1;  
  for (i=0;i<N;i++) {  
    *pint = i; 
    printf("Writing: Index %4d\tValue: %4d\tAddress: Ox%x\n",
                     i,*pint,pint);
    pint++; 
  } 
  /* leggo dalla regione 2 */ 
  pint = (int*)addr2; 
  for (i=0;i<N;i++) {  
    printf("Reading: Index %4d\tValue: %4d\tAddress: Ox%x\n",
                     i,*pint,pint);
    pint++;
  }
}
