/******************************************
MODULO: fork.c
SCOPO: esempio di creazione di un processo
******************************************/
#include <stdio.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <signal.h>
#include "mylib.h"

int first_time;

void masksig(int s)
{
	signal(s,SIG_IGN);
    puts ("Io sono il figlio!");
    puts ("Sto facendo operazioni critiche!");
	sleep(10);
}

int main (int argc, char *argv[])
{
  pid_t status, child;
  if ((status=fork()) == -1)
    perror("");
  if (status == 0) {
	signal(SIGHUP,masksig);
    puts ("Io sono il figlio!");
	sleep(100);
  }
  else  {
	sleep(3);
	/* non ignorata */
	kill(status,SIGHUP);
	kill(status,SIGHUP);
	kill(status,SIGHUP);
	kill(status,SIGHUP);
	sleep(3);
	/* ignorata */
	kill(status,SIGHUP);

	while ((child=wait(&status)) != -1) {
    printf ("il figlio con PID %d ", child);
    if (WIFEXITED(status)) {
      printf ("e` terminato (stato di uscita: %d)\n\n", 
		  WEXITSTATUS(status));
    } else if (WIFSIGNALED(status)) {
      printf ("e` stato ucciso (segnale omicida: %d)\n\n",
        WTERMSIG(status));
    } else if (WSTOPSIG(status)) {
      puts ("e` stato bloccato");
      printf ("(segnale bloccante: %d)\n\n",WSTOPSIG(status));
    } else
      puts ("non c'e` piu` !?");
  }
  return 0;
  }
}
