/******************************************
MODULO: wait.c
SCOPO: esempio d'uso di wait()
******************************************/
#include <stdio.h>
#include <unistd.h>
#include <sys/wait.h>

#include "mylib.h"

void sighandler(int x) 
{
	printf("I have been awakened!\n");
}

int main (int argc, char *argv[])
{
  pid_t child;
  int status;
  signal(SIGUSR1,sighandler);

  if ((child=fork()) == 0) {
    puts ("figlio 1 - termino con stato 3");
    _exit (3);
  }
  if (child == -1)
    syserr (argv[0], "fork() fallita");

  /* padre lavora, il figlio dovrebbe diventare  
	 zombie per un po' */
  sleep(10); 
  while ((child=wait(&status)) != -1) {
    printf ("il figlio con PID %d ", child);
    if (WIFEXITED(status)) {
      printf ("e` terminato (stato di uscita: %d)\n\n", 
		  WEXITSTATUS(status));
    } else if (WIFSIGNALED(status)) {
      printf ("e` stato ucciso (segnale omicida: %d)\n\n",
        WTERMSIG(status));
    } else if (WSTOPSIG(status)) {
      puts ("e` stato bloccato");
      printf ("(segnale bloccante: %d)\n\n",WSTOPSIG(status));
    } else
      puts ("non c'e` piu` !?");
  }
  return 0;
}
